﻿using Catamaran.Drawings;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Catamaran.CollectionGenericObjects
{
    public class Harbor : AbstractCompany
    {
        public Harbor(int picWidth, int picHeight, ICollectionGenericObjects<DrawingBoat> collection) : base(picWidth, picHeight, collection)
        {

        }

        protected override void DrawBackground(Graphics g)
        {
            Pen pen = new Pen(Color.Black, 4f);
            for (int i = 0; i < _pictureHeight / _placeSizeHeight / 2; i++)
            {
                g.DrawLine(pen, 0, _pictureHeight - i * _placeSizeHeight * 2, _placeSizeWidth * (_pictureWidth / _placeSizeWidth), _pictureHeight - i * _placeSizeHeight * 2);
                for (int j = 0; j < _pictureWidth / _placeSizeWidth + 1; j++)
                {
                    g.DrawLine(pen, _placeSizeWidth * j, _pictureHeight - i * _placeSizeHeight * 2, _placeSizeWidth * j, _pictureHeight - i * _placeSizeHeight * 2 - _placeSizeHeight);
                }
            }
        }


        protected override void SetObjectsPosition()
        {
            int curPosX = 0;
            int curPosY = 0;

            for (int i = 0; i < (_collection?.Count ?? 0); i++)
            {
                if (curPosX > _pictureWidth / _placeSizeWidth)
                {
                    return;
                }
                if (_collection?.Get(i) != null)
                {
                    _collection?.Get(i)?.SetPictureSize(_pictureWidth, _pictureHeight);
                    _collection?.Get(i)?.SetPosition(curPosX * _placeSizeWidth + 20, curPosY * _placeSizeHeight * -2 + (_pictureHeight - 60) );
                }

                if (curPosX < _pictureWidth / _placeSizeWidth - 1)
                {
                    curPosX++;
                }
                else
                {
                    curPosX = 0;
                    curPosY++;
                }
            }
        }
    }
}
