﻿using System;
using System.Collections.Generic;
using System.DirectoryServices;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Catamaran.Entities;

namespace Catamaran.Drawings
{
    public class DrawingCatamaran : DrawingBoat
    {

        
        public DrawingCatamaran(int speed, double weight, Color bodyColor, Color additionalColor, bool leftBobber, bool rightBobber, bool sail) : base(120, 90)
        {
            EntityBoat = new EntityCatamaran(speed, weight, bodyColor, additionalColor, leftBobber, rightBobber, sail);
        }


        public override void DrawTransport(Graphics g)
        {
            if (EntityBoat == null || EntityBoat is not EntityCatamaran EntityCatamaran || !_startPosX.HasValue || !_startPosY.HasValue)
            {
                return;
            }
            Pen pen = new(Color.Black);
            Brush baseBrush = new SolidBrush(EntityCatamaran.BodyColor);
            Brush additionalBrush = new SolidBrush(EntityCatamaran.AdditionalColor);
            Brush brBrush = new SolidBrush(Color.Brown);
            
            
            
            // левый поплавок
            if (EntityCatamaran.LeftBobber)
            {
                g.FillEllipse(additionalBrush, _startPosX.Value, _startPosY.Value + 8, 100, 15);
                g.DrawEllipse(pen, _startPosX.Value, _startPosY.Value + 8, 100, 15);

            }
            // правый поплавок
            if (EntityCatamaran.RightBobber)
            {
                g.FillEllipse(additionalBrush, _startPosX.Value, _startPosY.Value + 37, 100, 15);
                g.DrawEllipse(pen, _startPosX.Value, _startPosY.Value + 37, 100, 15);
            }
            
            // начало отрисовки
            
            _startPosX += 5;
            _startPosY += 5;
            base.DrawTransport(g);
            _startPosX -= 5;
            _startPosY -= 5;

            // конец отрисовки

            // парус
            if (EntityCatamaran.Sail)
            {
                Point[] sail =
                {
                    new Point(_startPosX.Value + 50, _startPosY.Value + 30),
                    new Point(_startPosX.Value + 50, _startPosY.Value + 5),
                    new Point(_startPosX.Value + 80, _startPosY.Value + 25),
                    new Point(_startPosX.Value + 50, _startPosY.Value + 25),
                };
                g.FillPolygon(additionalBrush, sail);
                g.DrawPolygon(pen, sail);
            }
        }
    }
}
