﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Catamaran.Entities
{
    public class EntityCatamaran : EntityBoat
    {

        public Color AdditionalColor { get; private set; }

        public bool LeftBobber { get; private set; }

        public bool RightBobber { get; private set; }

        public bool Sail { get; private set; }

        public double Step => Speed * 100 / Weight;

        public void SetAdditionalColor(Color addColor)
        {
            AdditionalColor = addColor;
        }

        public EntityCatamaran(int speed, double weight, Color bodyColor, Color additionalColor, bool leftBobber, bool rightBobber, bool sail) : base(speed, weight, bodyColor)
        {
            AdditionalColor = additionalColor;
            LeftBobber = leftBobber;
            RightBobber = rightBobber;
            Sail = sail;
        }
    }
}
