﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Catamaran.MovementStrategy
{
    public class MoveToBorder : AbstractStrategy
    {
        protected override bool IsTargetDestination()
        {
            ObjectParameters? objParams = GetObjectParameters;
            if (objParams == null)
            {
                return false;
            }
            return objParams.RightBorder + GetStep() >= FieldWidth &&
                objParams.DownBorder + GetStep() >= FieldHeight;
        }

        protected override void MoveToTarget()
        {
            ObjectParameters? objParams = GetObjectParameters;
            if (objParams == null)
            {
                return;
            }

            int diffX = objParams.RightBorder - FieldWidth;
            if (Math.Abs(diffX) > GetStep())
            {
                MoveRight();
            }
            
            int diffY = objParams.DownBorder - FieldHeight;
            if (Math.Abs(diffY) > GetStep())
            {
                MoveDown();
            }
        }


    }
}
